<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/mrl_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
.textRainbow_lv2_p0 { color: #e0ffff; }
.textRainbow_lv1_o0 { color: #ffffe0; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr"> 1 </span>01/30/84  mrl_
<span id="L2" class="LineNr"> 2 </span>
<span id="L3" class="LineNr"> 3 </span>Entry points in mrl_:
<span id="L4" class="LineNr"> 4 </span>     <span class="textRainbow_lv0_p0">(</span>list is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L5" class="LineNr"> 5 </span>
<span id="L6" class="LineNr"> 6 </span>
<span id="L7" class="LineNr"> 7 </span>:Entry: mrl_: 01/30/84  mrl_
<span id="L8" class="LineNr"> 8 </span>
<span id="L9" class="LineNr"> 9 </span>Function:  moves a character string by copying the characters from
<span id="L10" class="LineNr">10 </span>right to left.
<span id="L11" class="LineNr">11 </span>
<span id="L12" class="LineNr">12 </span>
<span id="L13" class="LineNr">13 </span>Syntax:
<span id="L14" class="LineNr">14 </span>declare mrl_ entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>21<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>21<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L15" class="LineNr">15 </span>call mrl_ <span class="textRainbow_lv0_p0">(</span>input_ptr<span class="textRainbow_lv0_o0">,</span> input_lth<span class="textRainbow_lv0_o0">,</span> output_ptr<span class="textRainbow_lv0_o0">,</span> output_lth<span class="textRainbow_lv0_p0">)</span>;
<span id="L16" class="LineNr">16 </span>
<span id="L17" class="LineNr">17 </span>
<span id="L18" class="LineNr">18 </span>Arguments:
<span id="L19" class="LineNr">19 </span>input_ptr
<span id="L20" class="LineNr">20 </span>   is a pointer to the input character string.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L21" class="LineNr">21 </span>input_lth
<span id="L22" class="LineNr">22 </span>   is the length of the input string in characters.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L23" class="LineNr">23 </span>output_ptr
<span id="L24" class="LineNr">24 </span>   is a pointer to the output character string.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L25" class="LineNr">25 </span>output_lth
<span id="L26" class="LineNr">26 </span>   is the length of the output string in characters.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L27" class="LineNr">27 </span>
<span id="L28" class="LineNr">28 </span>
<span id="L29" class="LineNr">29 </span>Notes: If the output string is shorter than the input string, only the
<span id="L30" class="LineNr">30 </span>last output_lth characters of the input string are moved.  If the
<span id="L31" class="LineNr">31 </span>output string is longer than the input string, the output string is
<span id="L32" class="LineNr">32 </span>padded on the left with blanks.
<span id="L33" class="LineNr">33 </span>
<span id="L34" class="LineNr">34 </span>
<span id="L35" class="LineNr">35 </span>The following call to mrl_ --
<span id="L36" class="LineNr">36 </span>
<span id="L37" class="LineNr">37 </span>     call mrl_ <span class="textRainbow_lv0_p0">(</span>addcharno <span class="textRainbow_lv1_p0">(</span>addr <span class="textRainbow_lv2_p0">(</span>text<span class="textRainbow_lv2_p0">)</span><span class="textRainbow_lv1_o0">,</span> start<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> lth<span class="textRainbow_lv0_o0">,</span>
<span id="L38" class="LineNr">38 </span>                addcharno <span class="textRainbow_lv1_p0">(</span>addr <span class="textRainbow_lv2_p0">(</span>text<span class="textRainbow_lv2_p0">)</span><span class="textRainbow_lv1_o0">,</span> start+N<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> lth<span class="textRainbow_lv0_p0">)</span>;
<span id="L39" class="LineNr">39 </span>
<span id="L40" class="LineNr">40 </span>where N is a positive number is equivalent to the following PL/I loop--
<span id="L41" class="LineNr">41 </span>
<span id="L42" class="LineNr">42 </span>     do i = lth to 1 by -1;
<span id="L43" class="LineNr">43 </span>       substr <span class="textRainbow_lv0_p0">(</span>text<span class="textRainbow_lv0_o0">,</span> <span class="textRainbow_lv1_p0">(</span>start+N+i-1<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> 1<span class="textRainbow_lv0_p0">)</span> = substr <span class="textRainbow_lv0_p0">(</span>text<span class="textRainbow_lv0_o0">,</span> <span class="textRainbow_lv1_p0">(</span>start+i-1<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> 1<span class="textRainbow_lv0_p0">)</span>;
<span id="L44" class="LineNr">44 </span>     end;
<span id="L45" class="LineNr">45 </span>
<span id="L46" class="LineNr">46 </span>Due to the nature of the Multics hardware, if the input and output
<span id="L47" class="LineNr">47 </span>strings overlap and the output string is to the left of the input
<span id="L48" class="LineNr">48 </span>string <span class="textRainbow_lv0_p0">(</span>ie: N<span class="textRainbow_lv0_o0">,</span> above<span class="textRainbow_lv0_o0">,</span> were a negative number<span class="textRainbow_lv0_p0">)</span>, the results of the call
<span id="L49" class="LineNr">49 </span>to mrl_ will be different from the results of the above PL/I loop.
<span id="L50" class="LineNr">50 </span>
<span id="L51" class="LineNr">51 </span>
<span id="L52" class="LineNr">52 </span>Note that the following PL/I statement --
<span id="L53" class="LineNr">53 </span>
<span id="L54" class="LineNr">54 </span>     substr <span class="textRainbow_lv0_p0">(</span>text<span class="textRainbow_lv0_o0">,</span> start+N<span class="textRainbow_lv0_o0">,</span> lth<span class="textRainbow_lv0_p0">)</span> = substr <span class="textRainbow_lv0_p0">(</span>text<span class="textRainbow_lv0_o0">,</span> start<span class="textRainbow_lv0_o0">,</span> lth<span class="textRainbow_lv0_p0">)</span>;
<span id="L55" class="LineNr">55 </span>
<span id="L56" class="LineNr">56 </span>will not work properly as the code generated by the compiler moves the
<span id="L57" class="LineNr">57 </span>character string from left to right which destroys the contents of the
<span id="L58" class="LineNr">58 </span>string.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
